//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

int x(int uid, const unsigned char* cmd) {
	unsigned char response[500];
	if (userpointers[uid]->authed == true) {
		return 0;
	}else{
		if (strcasecmp(userpointers[uid]->nickname,"") != 0) {
			snprintf(&response[0],499,":%s 451 %s %s :Please register first.",cuo.svd,un(uid),cmd);
		}else{
			snprintf(&response[0],499,":%s 451 * %s :Please register first.",cuo.svd,cmd);
		}
		response[499] = 0;
		vsnd(response,uid);
		return -1;
	}
}
void cmd_mode(int clientnr, unsigned char* stringle) {
	unsigned char vsndstr[500];
	unsigned char tp[500];
	int k;
	if (x(clientnr,"MODE")) {return;}
	trimleft(stringle);
	if (strcasecmp(stringle,"") == 0) {notenoughparameters(clientnr,"MODE");return;}
	strncpy(tp,stringle,499);tp[499] = 0;
	cutonfirstspace(tp);
	if (strlen(tp) > 50) {tp[50] = 0;}
	if (tp[0] == 35) {//channel
		k = getChanID(tp);
		if (k < 0) {
			snprintf(&vsndstr[0],499,":%s 403 %s %s :No such channel",cuo.svd,getnik(clientnr),tp);
			vsndstr[499] = 0;
			vsnd(vsndstr,clientnr);
			return;
		}
		allesnachzeichen(32,stringle,stringle);
		if (strcasecmp(stringle,"") == 0 || strcasecmp(stringle,"+") == 0 || strcasecmp(stringle,"-") == 0) {
			if (isuserinchan(clientnr,k) == false) {
				sendchanmodes_user(clientnr,k,true);
			}else{
				sendchanmodes_user(clientnr,k,false);
			}
			return;
		}else{
			if (isuserinchan(clientnr,k) == false) {
				snprintf(&vsndstr[0],499,":%s 442 %s %s :You are not on that channel",cuo.svd,getnik(clientnr),chans[k]->name);
				vsndstr[499] = 0;
				vsnd(vsndstr,clientnr);
				return;
			}
			parsemodes_chan(clientnr,k,stringle);return;
		}
		return;
	}else{
		int r = 0;
		r = ubn(tp);
		if (r < 0) {
			snprintf(&vsndstr[0],499,":%s 401 %s %s :No such nick",cuo.svd,getnik(clientnr),tp);
			vsndstr[499] = 0;
			vsnd(vsndstr,clientnr);
			return;
		}
		if (r != clientnr) {
			snprintf(&vsndstr[0],499,":%s 502 %s :Can't change modes for other users",cuo.svd,getnik(clientnr));
			vsndstr[499] = 0;
			vsnd(vsndstr,clientnr);
			return;
		}
		allesnachzeichen(32,stringle,stringle);
		trimleft(stringle);
		cutonfirstspace(stringle);
		if (strcasecmp(stringle,"") != 0 && strcasecmp(stringle,"+") != 0) {
			parsemodes_user(clientnr,stringle);
		}else{
			strcpy(stringle,"+");
			if (userpointers[clientnr]->mode_invisible == true) {strcat(stringle,"i");}
			if (userpointers[clientnr]->ircop == true) {strcat(stringle,"os");}
			if (userpointers[clientnr]->mode_walluser == true) {strcat(stringle,"w");}
			if (userpointers[clientnr]->mode_bot == true) {strcat(stringle,"B");}
			snprintf(&vsndstr[0],499,":%s 221 %s %s\0",cuo.svd,getnik(clientnr),stringle);
			vsndstr[499] = 0;
			vsnd(vsndstr,clientnr);
			return;
		}
	}
	return;
}
bool isxchatstuff(const unsigned char* blubb) {//test for xchat /list parameters which aren't supported
	if (strlen(blubb) < 2) {return false;}
	int r = 0;int number = 0;int biggersmaller = 0;
	while (r < strlen(blubb)) {
		if ((blubb[r] < '0' || blubb[r] > '9') && blubb[r] != ',' && blubb[r] != '<' && blubb[r] != '>') {return false;}
		if (blubb[r] >= '0' && blubb[r] <= '9') {number++;}
		if (blubb[r] == '>' || blubb[r] == '<') {biggersmaller++;}
		r++;
	}
	if (biggersmaller <= 0 || number <= 0) {return false;}
	return true;
}
void cmd_list(int clientnr, unsigned char* stringle) {
	unsigned char vsndstr[500];
	int fcount2,r;
	if (x(clientnr,"LIST")) {return;}
	userpointers[clientnr]->floodprotect.floodpoints += 2;
	trimleft(stringle);
	if (strlen(stringle) > 0) {
		cutonfirstspace(stringle);
		allesvorzeichen(',',stringle,stringle);
		allesvorzeichen(' ',stringle,stringle);
		if (strcasecmp(stringle,"*") == 0 || strcasecmp(stringle,"0") == 0) {strcpy(stringle,"");}
		stringle[50] = 0;
	}
	if (strcasecmp(stringle,"") == 0) {
		if (userpointers[clientnr]->floodprotect.lastlist + 3 > time(NULL) && userpointers[clientnr]->ircop == false) {
			userQuit(clientnr,USERQUIT_EXCESSFLOOD);
			return;
		}
		userpointers[clientnr]->floodprotect.lastlist = time(NULL);
	}
	removeemptychans();
	snprintf(&vsndstr[0],499,":%s 321 %s Channel :Users Name",cuo.svd,un(clientnr));
	vsndstr[499] = 0;
	vsnd(vsndstr,clientnr);
	if (strcasecmp(stringle,"") == 0 || isxchatstuff(stringle) == true) {
		r = 0;
		while (r < COMPILEOPTION_MAXCHANS) {
			if (chans[r] != NULL) {
				if (chans[r]->mode_private == false || userpointers[clientnr]->ircop == true) {
					fcount2 = chanusercount(r);
					if (fcount2 > 0) {	
						snprintf(&vsndstr[0],499,":%s 322 %s %s %d :%s",cuo.svd,un(clientnr),chans[r]->name,fcount2,chans[r]->topic);
						vsndstr[499] = 0;
						vsnd(vsndstr,clientnr);
					}
				}
			}
			r += 1;
		}
	}else{
		r = 0;
		while (r < COMPILEOPTION_MAXCHANS) {
			if (chans[r] != NULL) {
				if (chans[r]->mode_private == false || userpointers[clientnr]->ircop == true) {
					if (strcasecmp(chans[r]->name,stringle) == 0) {
						fcount2 = chanusercount(r);
						if (fcount2 > 0) {
							snprintf(&vsndstr[0],499,":%s 322 %s %s %d :%s",cuo.svd,un(clientnr),chans[r]->name,fcount2,chans[r]->topic);
							vsndstr[499] = 0;
							vsnd(vsndstr,clientnr);
						}
						break;
					}
				}
			}
			r += 1;
		}
	}
	snprintf(&vsndstr[0],499,":%s 323 %s :End of /LIST",cuo.svd,un(clientnr));
	vsndstr[499] = 0;
	vsnd(vsndstr,clientnr);
}
void cmd_topic(int clientnr, unsigned char* stringle) {
	unsigned char mystringle_replace[600];
	unsigned char vsndstr[500];
	if (x(clientnr,"TOPIC")) {return;}
	userpointers[clientnr]->floodprotect.floodpoints += 1;
	if (strcasecmp(stringle,"") == 0) {notenoughparameters(clientnr,"TOPIC");return;}
	strncpy(mystringle_replace,stringle,599);mystringle_replace[599] = 0;
	cutonfirstspace(mystringle_replace);
	allesnachzeichen(32,stringle,stringle);
	trimleft(stringle);trimleft(mystringle_replace);
	mystringle_replace[50] = 0;
	int k = getChanID(mystringle_replace);
	if (k < 0) {
		snprintf(&vsndstr[0],499,":%s 403 %s %s :No such channel",cuo.svd,un(clientnr),mystringle_replace);
		vsndstr[499] = 0;
		vsnd(vsndstr,clientnr);
		return;
	}
	if (strcasecmp(stringle,"") == 0) {//topicauskunft bitte
		if (isuserinchan(clientnr,k) == false && chans[k]->mode_private == true && userpointers[clientnr]->ircop == false) {
			snprintf(&vsndstr[0],499,":%s 442 %s %s :You are not on that channel",cuo.svd,un(clientnr),chans[k]->name);
			vsndstr[499] = 0;
			vsnd(vsndstr,clientnr);
			return;
		}
		sendtopic(clientnr,k);
		return;
	}else{//topic soll gesetzt werden
		if (isuserinchan(clientnr,k) == false && chans[clientnr]->name == false) {
			snprintf(&vsndstr[0],499,":%s 442 %s %s :You are not on that channel",cuo.svd,un(clientnr),chans[k]->name);
			vsndstr[499] = 0;
			vsnd(vsndstr,clientnr);
			return;
		}
		if (strstw(stringle,":") == true) {cut(stringle,1);}
		if (strlen(stringle) > 200) {stringle[200] = 0;}
		if (chans[k]->mode_topiclock == true) {
			if (isoponchan(clientnr,k) == false && ishoponchan(clientnr,k) == false) {
				snprintf(&vsndstr[0],499,":%s 482 %s %s :You need to be channel operator to do that",cuo.svd,un(clientnr),chans[k]->name);
				vsndstr[499] = 0;
				vsnd(vsndstr,clientnr);
				return;
			}
		}
		strncpy(chans[k]->topic,stringle,MAXTOPICLEN - 1);chans[k]->topic[MAXTOPICLEN - 1] = 0;
		strncpy(chans[k]->topic_setby,getnik(clientnr),49);chans[k]->topic_setby[49] = 0;
		chans[k]->topic_settime = time(NULL);
		snprintf(&vsndstr[0],499,":%s!%s@%s TOPIC %s :%s",un(clientnr),userpointers[clientnr]->suserid,userpointers[clientnr]->host,chans[k]->name,chans[k]->topic);
		vsndstr[499] = 0;
		tellallusersinchan(vsndstr,k);
#ifdef SERVICES_ENABLED
		if (cuo.services_activated == 1) {
			if (chanregistered(chans[k]->name) == true) {
				services_setchantopic(chans[k]->name,chans[k]->topic);
			}
		}
#endif
		return;
	}
	return;
}
void cmd_oper(int userid, unsigned char* params) {
	unsigned char response[500];
	unsigned char oname[500];
	unsigned char opw[500];
	if (x(userid,"OPER")) {return;}
	trimleft(params);trimright(params);
	if (charpos(params,' ') < 0) {
		notenoughparameters(userid,"OPER");return;
	}
	if (userpointers[userid]->ircop == true) {return;}
	allesvorzeichen(' ',oname,params);
	allesnachzeichen(' ',opw,params);
	int k = 0;
	while (k < MAXOLINECOUNT) {
		if (cuo.opers[k] != NULL) {
			if (strcmp(cuo.opers[k]->accountname,oname) == 0) {
				if (strcmp(cuo.opers[k]->password,opw) != 0) {
					snprintf(&response[0],499,":%s 491 %s :No O-lines for your host.",cuo.svd,un(userid));
					response[499] = 0;vsnd(response,userid);
					return;
				}else{
					userpointers[userid]->ircop = true;
					snprintf(&response[0],499,":%s 381 %s :You are an IRC operator now.",cuo.svd,un(userid));
					response[499] = 0;vsnd(response,userid);
					return;
				}
			}
		}
		k += 1;
	}
	snprintf(&response[0],499,":%s 491 %s :No O-lines for your host.",cuo.svd,un(userid));
	response[499] = 0;vsnd(response,userid);
}
void cmd_kill(int userid, unsigned char* params) {
	unsigned char response[500];
	unsigned char oname[500];
	unsigned char oreason[500];
	if (x(userid,"KILL")) {return;}
	trimleft(params);trimright(params);
	if (charpos(params,' ') < 0) {
		notenoughparameters(userid,"KILL");return;
	}
	if (userpointers[userid]->ircop == false) {
		snprintf(&response[0],499,":%s 481 %s :Permission Denied: Insufficient privileges",cuo.svd,un(userid));
		response[499] = 0;vsnd(response,userid);
		return;
	}
	allesvorzeichen(' ',oname,params);
	allesnachzeichen(' ',oreason,params);
	if (strstw(oreason,":") == true) {cut(oreason,1);}
	trimleft(oreason);
	if (strcasecmp(oreason,"") == 0) {notenoughparameters(userid,"KILL");return;}
	int r = ubn(oname);
	if (r < 0) {
		snprintf(&response[0],499,":%s 401 %s %s :No such user",cuo.svd,un(userid),oname);
		vsnd(response,userid);
		return;
	}
	snprintf(&oname[0],499,"Killed by %s (%s)",un(userid),oreason);
	oname[499] = 0;
	userpointers[r]->quitreason = malloc(strlen(oname) + 1);
	if (userpointers[r]->quitreason != NULL) {
		strcpy(userpointers[r]->quitreason,oname);
		snprintf(&oname[0],499,"ERROR :Killed by %s: %s",un(userid),oreason);
		oname[499] = 0;
		vsnd(oname,r);
		userQuit(r,USERQUIT_ERROR);
	}else{
		IOnotice("KILL: ERROR: OUT OF MEMORY");
	}
}
void cmd_kick(int userid, unsigned char* params) {
	unsigned char response[500];
	if (x(userid,"KICK")) {return;}
	trimleft(params);
	if (strcasecmp(params,"") == 0 || charpos(params,' ') <= 0) {
		notenoughparameters(userid,"KICK");return;
	}
	unsigned char chan[300];
	strncpy(chan,params,299);chan[299] = 0;
	chan[charpos(chan,' ')] = 0;cut(params,charpos(params,' ')+1);
	cutonfirstspace(chan);
	trimleft(params);
	unsigned char usr[300];
	if (strcasecmp(params,"") == 0 || charpos(params,':') <= 0) {
		strncpy(usr,params,299);usr[299] = 0;cutonfirstspace(usr);
		strcpy(params,un(userid));
	}else{
		strncpy(usr,params,299);usr[299] = 0;
		usr[charpos(usr,':')] = 0;cut(params,charpos(params,':')+1);
		cutonfirstspace(usr);trimleft(params);trimright(params);
	}
	int r = getChanID(chan);
	if (r < 0) {
		snprintf(&response[0],499,":%s 403 %s %s :No such channel",cuo.svd,un(userid),chan);
		response[499] = 0;vsnd(response,userid);
		return;
	}
	if (isuserinchan(userid,r) == false && userpointers[userid]->ircop == false) {
		snprintf(&response[0],499,":%s 482 %s %s :You are not a channel operator",cuo.svd,un(userid),chans[r]->name);
		response[499] = 0;vsnd(response,userid);
		return;
	}
	int k = ubn(usr);
	if (k < 0) {
		snprintf(&response[0],499,":%s 401 %s %s :No such user",cuo.svd,un(userid),usr);
		response[499] = 0;vsnd(response,userid);
		return;
	}
	if (isuserinchan(k,r) == false) {
		snprintf(&response[0],499,":%s 441 %s %s %s :They aren't on that channel",cuo.svd,un(userid),un(k),chans[r]->name);
		response[499] = 0;vsnd(response,userid);
		return;
	}
	if (ishoponchan(userid,r) == false && isoponchan(userid,r) == false && userpointers[userid]->ircop == false) {
		snprintf(&response[0],499,":%s 482 %s %s :You are not a channel operator",cuo.svd,un(userid),chans[r]->name);
		response[499] = 0;vsnd(response,userid);
		return;
	}
	if (ishoponchan(k,r) == true && isoponchan(userid,r) == false && userpointers[userid]->ircop == false) {
		snprintf(&response[0],499,":%s 482 %s %s :You are not a channel operator",cuo.svd,un(userid),chans[r]->name);
		response[499] = 0;vsnd(response,userid);
		return;
	}
	if (isprotectedonchan(k,r) == true) {
		snprintf(&response[0],499,":%s 482 %s %s :That person is protected",cuo.svd,un(userid),chans[r]->name);
		response[499] = 0;vsnd(response,userid);
		return;
	}
	snprintf(&response[0],499,":%s!%s@%s KICK %s %s :%s",un(userid),userpointers[userid]->suserid,userpointers[userid]->host,chans[r]->name,un(k),params);
	response[499] = 0;
	tellallusersinchan(response,r);
	int j = 0;
	while (j < COMPILEOPTION_MAXCHANSPERUSER) {
		if (userpointers[k]->chan[j] != NULL) {
			if (userpointers[k]->chan[j]->chanid == r) {free(userpointers[k]->chan[j]);userpointers[k]->chan[j] = NULL;}
		}
		j += 1;
	}
}
void cmd_away(int userid, unsigned char* params) {
	unsigned char response[500];
	if (x(userid,"AWAY")) {return;}
	trimleft(params);cutonfirstspace(params);
	if (strstw(params,":") == true) {cut(params,1);}
	if (strcasecmp(params,"") == 0) {//back
		if (userpointers[userid]->awayreason != NULL) {
			strcpy(userpointers[userid]->awayreason,"");
		}
		snprintf(&response[0],499,":%s 305 %s :You are no longer marked as being away.",cuo.svd,un(userid));
		response[499] = 0;vsnd(response,userid);
	}else{
		if (userpointers[userid]->awayreason == NULL) {
			userpointers[userid]->awayreason = malloc(COMPILEOPTION_MAXAWAYLEN + 1);
		}
		if (userpointers[userid]->awayreason != NULL) {
			strncpy(userpointers[userid]->awayreason,params, COMPILEOPTION_MAXAWAYLEN);
			userpointers[userid]->awayreason[COMPILEOPTION_MAXAWAYLEN] = 0;
			snprintf(&response[0],499,":%s 306 %s :You are now marked as away.",cuo.svd,un(userid));
			response[499] = 0;vsnd(response,userid);
		}
	}
}
void cmd_who(int userid, unsigned char* params) {
	unsigned char response[500];
	if (x(userid,"WHO")) {return;}
	trimleft(params);cutonfirstspace(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"WHO");return;
	}
	int r = ubn(params);
	int cc = 0;
	if (r >= 0) {
		if (userpointers[r]->pleaseremove == false && userpointers[r]->authed == true) {
			int i = 0;int chanid = -1;
			while (i < COMPILEOPTION_MAXCHANSPERUSER) {
				if (userpointers[r]->chan[i] != NULL) {
					if (chans[userpointers[r]->chan[i]->chanid]->mode_private == false) {
						chanid = userpointers[r]->chan[i]->chanid;
						break;
					}
				}
				i++;
			}
			sendwho(chanid,r,userid);
		}
	}else{
		r = getChanID(params);
		if (r >= 0) {
			if (isuserinchan(userid,r) == true || userpointers[userid]->ircop == true) {
				int i = 0;
				while (i < COMPILEOPTION_MAXUSERS) {
					if(userpointers[i] != NULL) {
						if (userpointers[i]->pleaseremove != true) {
							if (isuserinchan(i,r) == true) {
								sendwho(r,i,userid);
								cc++;
								if (cc > 30) {break;}
							}
						}
					}
					i++;
				}
			}
		}
	}
	snprintf(&response[0],499,":%s 315 %s %s :End of /WHO list.",cuo.svd,un(userid),params);
	response[499] = 0;vsnd(response,userid);
}
void cmd_ison(int userid, unsigned char* params) {
	unsigned char response[500];
	if (x(userid,"ISON")) {return;}
	trimleft(params);cutonfirstspace(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"ISON");return;
	}
	int r = ubn(params);
	if (r >= 0) {
		snprintf(&response[0],499,":%s 303 %s :%s",cuo.svd,un(userid),un(r));
		response[499] = 0;vsnd(response,userid);
	}else{
		snprintf(&response[0],499,":%s 303 %s :",cuo.svd,un(userid));
		response[499] = 0;vsnd(response,userid);
	}
}
void cmd_whowas(int userid, unsigned char* params) {
	unsigned char response[500];
	if (x(userid,"WHOWAS")) {return;}
	trimleft(params);cutonfirstspace(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"WHOWAS");return;
	}
	snprintf(&response[0],499,":%s 406 %s %s :There was no such nickname.",cuo.svd,un(userid),params);
	response[499] = 0;vsnd(response,userid);
	snprintf(&response[0],499,":%s 369 %s %s :End of /WHOWAS.",cuo.svd,un(userid),params);
	response[499] = 0;vsnd(response,userid);
}
void cmd_names(int userid, unsigned char* params) {
	unsigned char response[500];
	if (x(userid,"NAMES")) {return;}
	trimleft(params);cutonfirstspace(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"NAMES");return;
	}
	int r = getChanID(params);
	if (r < 0) {
		snprintf(&response[0],499,":%s 366 %s %s :End of /NAMES list",cuo.svd,un(userid),params);
		response[499] = 0;vsnd(response,userid);
		return;
	}else{
		if (isuserinchan(userid,r) == false && userpointers[userid]->ircop == false) {
			snprintf(&response[0],499,":%s 353 %s = %s :",cuo.svd,un(userid),chans[r]->name);
			response[499] = 0;vsnd(response,userid);
			snprintf(&response[0],499,":%s 366 %s %s :End of /NAMES list",cuo.svd,un(userid),chans[r]->name);
		response[499] = 0;vsnd(response,userid);
		}else{
			sendchanusers(userid,r);
		}
	}
}
void cmd_pass(int userid, unsigned char* params) {
	unsigned char response[500];
	if (strcasecmp(userpointers[userid]->nickname,"") != 0 && strcasecmp(userpointers[userid]->suserid,"") != 0) {
		if (strcasecmp(userpointers[userid]->nickname,"") == 0) {
			snprintf(&response[0],499,":%s 462 * :Please register only once",cuo.svd);
		}else{
			snprintf(&response[0],499,":%s 462 %s :Please register only once",cuo.svd,un(userid));
		}
		response[499] = 0;
		vsnd(response,userid);
		return;
	}
	if (strcasecmp(userpointers[userid]->pass,"") != 0) {
		if (strcasecmp(userpointers[userid]->nickname,"") == 0) {
			snprintf(&response[0],499,":%s 462 * :Please register only once",cuo.svd);
		}else{
			snprintf(&response[0],499,":%s 462 %s :Please register only once",cuo.svd,un(userid));
		}
		response[499] = 0;
		vsnd(response,userid);
		return;
	}
	if (strstw(params,":") == true) {cut(params,1);}
	trimleft(params);
	cutonfirstspace(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"PASS");return;
	}
	strcpy(userpointers[userid]->pass,params);
}
void cmd_rehash(int userid, unsigned char* params) {
	if (x(userid,"REHASH")) {return;}
	unsigned char temp[500];
	if (userpointers[userid]->ircop == false) {
		snprintf(&temp[0],499,":%s 481 %s :Permission Denied: Insufficient privileges",cuo.svd,un(userid));
		temp[499] = 0;vsnd(temp,userid);
		return;
	}
	int services_before = cuo.services_activated;
	IOnotice("[CONFIG] Rehashing...");
	if (readconfig(1) < 0) {
		IOnotice("[CONFIG] Rehashing failed.");
		return;
	}else{
		printf("[CONFIG] döne.");
#ifdef SERVICES_ENABLED
		if (services_before != cuo.services_activated) {//something changed!
			if (cuo.services_activated == 1) {//make chanserv join all the channels again
				int r = 0;
				while (r < COMPILEOPTION_MAXUSERS) {
					if (userpointers[r] != NULL) {
						if (userpointers[r]->authed == true && userpointers[r]->pleaseremove == false) {
							int k = 0;
							while (k < COMPILEOPTION_MAXCHANSPERUSER) {
								if (userpointers[r]->chan[k] != NULL) {
									if (chans[userpointers[r]->chan[k]->chanid]->mode_registered == true) {
										snprintf(temp,499,":ChanServ!services@%s JOIN :%s",cuo.serviceshost,chans[userpointers[r]->chan[k]->chanid]->name);
										temp[499] = 0;vsnd(temp,r);
										snprintf(temp,499,":ChanServ!services@%s MODE %s +o ChanServ",cuo.serviceshost,chans[userpointers[r]->chan[k]->chanid]->name);
										temp[499] = 0;vsnd(temp,r);
									}
								}
								k++;
							}
						}
					}
					r++;
				}
			}else{//have chanserv leave
				int r = 0;
				while (r < COMPILEOPTION_MAXUSERS) {
					if (userpointers[r] != NULL) {
						if (userpointers[r]->authed == true && userpointers[r]->pleaseremove == false) {
							int k = 0;
							while (k < COMPILEOPTION_MAXCHANSPERUSER) {
								if (userpointers[r]->chan[k] != NULL) {
									if (chans[userpointers[r]->chan[k]->chanid]->mode_registered == true) {
										snprintf(temp,499,":ChanServ!services@%s QUIT :Services are shutting down",cuo.serviceshost);
										temp[499] = 0;vsnd(temp,r);
										break;
									}
								}
								k++;
							}
						}
					}
					r++;
				}
			}
		}
#endif
	}
}
void cmd_join(int userid, unsigned char* params) {
	if (x(userid,"JOIN")) {return;}
	unsigned char response[500];
	if (strstw(params,":") == true) {cut(params,1);}trimleft(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"JOIN");return;
	}
	cutonfirstspace(params);
	unsigned char tp1[500];
	unsigned char tp2[500];
	strncpy(tp1,params,499);tp1[499] = 0;
	int r = 0;
	while (charpos(tp1,',') > 0) {
		allesvorzeichen(',',tp2,tp1);
		allesnachzeichen(',',tp1,tp1);
		moveintochan(userid,tp2);
	}
	moveintochan(userid,tp1);
}
void cmd_part(int userid, unsigned char* params) {
	if (x(userid,"JOIN")) {return;}
	unsigned char response[500];
	if (strstw(params,":") == true) {cut(params,1);}trimleft(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"JOIN");return;
	}
	cutonfirstspace(params);
	unsigned char tp1[500];
	unsigned char tp2[500];
	strncpy(tp1,params,499);tp1[499] = 0;
	int r = 0;
	while (charpos(tp1,',') > 0) {
		allesvorzeichen(',',tp2,tp1);
		allesnachzeichen(',',tp1,tp1);
		moveoutofchan(userid,tp2,"");
	}
	moveoutofchan(userid,tp1,"");
}
void cmd_gline(int userid, unsigned char* params) {
	if (x(userid,"GLINE")) {return;}
	unsigned char response[500];
	if (userpointers[userid]->ircop == false) {
		snprintf(response,499,":%s 481 %s :Permission Denied: You do not have the correct IRC operator privileges",cuo.svd,un(userid));
		response[499] = 0;
		vsnd(response,userid);
		return;
	}
	if (strcasecmp(params,"") == 0) {//list glines
		listglines(userid);
		return;
	}
	trimleft(params);trimright(params);
	if (strcasecmp(params,"list") == 0 || strstw(params,"list ") == true) {
		listglines(userid);
		return;
	}
	if (params[0] == '+') {
		cut(params,1);
		if (strlen(params) <= 1 || charpos(params,' ') <= 0 || charpos(params,' ') >= strlen(params)-1) {
			notenoughparameters(userid,"GLINE");return;
		}
		unsigned char willmask[400];
		strncpy(willmask,params,399);if (charpos(willmask,' ') > 0) {willmask[charpos(willmask,' ')] = 0;}
		willmask[399] = 0;
		cut(params,charpos(params,' ')+1);
		if (charpos(params,' ') <= 0) {
			notenoughparameters(userid,"GLINE");return;
		}
		unsigned char tmp[400];
		strncpy(tmp,params,399);if (charpos(tmp,' ') > 0) {tmp[charpos(tmp,' ')] = 0;}
		tmp[399] = 0;
		cut(params,charpos(params,' ')+1);
		trimleft(params);trimright(params);
		if (strlen(params) < 1) {
			snprintf(response,499,":%s NOTICE %s :Please always give a reason for g-line.",cuo.svd,un(userid));
			response[499] = 0;
			vsnd(response,userid);
			return;
		}
		addgline(userid,willmask,tmp,params);
		return;
	}else{
		if (params[0] != '-') {notenoughparameters(userid,"GLINE");return;}
		cut(params,1);
		trimleft(params);
		cutonfirstspace(params);
		if (strlen(params) < 1) {notenoughparameters(userid,"GLINE");return;}
		delgline(userid,params);
		return;
	}
}
void cmd_stats(int userid, unsigned char* params) {
	if (x(userid,"STATS")) {return;}
	unsigned char response[500];
	snprintf(response,499,":%s 481 %s :Permission Denied: You do not have the correct IRC operator privileges",cuo.svd,un(userid));
	response[499] = 0;
	vsnd(response,userid);
}
void cmd_nick(int userid, unsigned char* params) {
	unsigned char response[500];
	if (strstw(params,":") == true) {cut(params,1);}trimleft(params);cutonfirstspace(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"NICK");return;
	}
	if (nicknamevalid(params) == false) {
		if (strcasecmp(userpointers[userid]->nickname,"") == 0) {
			snprintf(&response[0],499,":%s 432 * %s :Erroneous Nickname",cuo.svd,params);
		}else{
			snprintf(&response[0],499,":%s 432 %s %s :Erroneous Nickname",cuo.svd,userpointers[userid]->nickname,params);
		}
		response[499] = 0;
		vsnd(response,userid);
		return;
	}
	if (strlen(params) > COMPILEOPTION_MAXNICKLEN) {
		snprintf(&response[0],499,":%s 432 * %s :Nickname is too long (only %d chars allowed)",cuo.svd,params,COMPILEOPTION_MAXNICKLEN);
		response[499] = 0;
		vsnd(response,userid);
		return;
		
	}
	if (strcasecmp(un(userid),"") == 0 || strcasecmp(un(userid),params) != 0) {
		if (nickused(params) == true || isfakeuser(params) == true) {
			if (strcasecmp(userpointers[userid]->nickname,"") == 0) {
				snprintf(&response[0],499,":%s 433 * %s :Nickname is already in use",cuo.svd,params);
			}else{
				snprintf(&response[0],499,":%s 433 %s %s :Nickname is already in use",cuo.svd,userpointers[userid]->nickname,params);
			}
			response[499] = 0;
			vsnd(response,userid);
			return;
		}
	}
	userpointers[userid]->needstimeout = 0;
	if (strcmp(un(userid),params) == 0) {//nickname is exactly the same, no change needed
		return;
	}
	if (strcasecmp(userpointers[userid]->nickname,"") != 0) {
		int gip = getIpID(userpointers[userid]->ip);
		if (gip >= 0) {
			if (ips[gip]->nicklock > time(NULL)) {
				snprintf(&response[0],499,":%s 438 %s :Nickchange too fast",cuo.svd,un(userid));
				response[499] = 0;
				vsnd(response,userid);
				return;
			}
		}
#ifdef SERVICES_ENABLED
		if (cuo.services_activated == 1) {
			if (strstw(params,"guest") == false && services_userregistered(params) == true) {
				if (userpointers[userid]->accountname == NULL) {
#ifdef SERVICES_ENFORCEPROTECT
					snprintf(&response[0],499,":%s 433 %s %s :Nickname is registered",cuo.svd,userpointers[userid]->nickname,params);
					response[499] = 0;
					vsnd(response,userid);
					return;
#endif
					services_say("NickServ","This nickname is registered. Please login if it has been registered by you.",userid);
					userpointers[userid]->needstimeout = 1;
					if (SERVICES_LOGINTIMEOUT > 0) {
						sprintf(&response[0],"You have %c%d seconds%c to login or you will be renamed.",2,SERVICES_LOGINTIMEOUT,2);
						services_say("NickServ",response,userid);
					}
				}else{
					if (strcasecmp(userpointers[userid]->accountname,params) != 0) {
#ifdef SERVICES_ENFORCEPROTECT
						snprintf(&response[0],499,":%s 433 %s %s :Nickname is registered",cuo.svd,userpointers[userid]->nickname,params);
						response[499] = 0;
						vsnd(response,userid);
						return;
#endif
						services_say("NickServ","This nickname is registered. Please login if it has been registered by you.",userid);
						userpointers[userid]->needstimeout = 1;
						if (SERVICES_LOGINTIMEOUT > 0) {
							sprintf(&response[0],"You have %c%d seconds%c to login or you will be renamed.",2,SERVICES_LOGINTIMEOUT,2);
							services_say("NickServ",response,userid);
						}
					}
				}
			}else{
				if (services_userregistered(params) == false) {
					userpointers[userid]->notifyregistered = 0;
					userpointers[userid]->needstimeout = 0;
				}
			}
		}
#endif
		snprintf(&response[0],499,":%s!%s@%s NICK %s",un(userid),userpointers[userid]->suserid,userpointers[userid]->host,params);
		response[499] = 0;
		vsnd(response,userid);
		tellaffectedusers(response,userid);
	}
	if (strcasecmp(un(userid),params) != 0) {
		userpointers[userid]->lastnickchange = time(NULL);
	}
	strcpy(userpointers[userid]->nickname,params);
	if (strcasecmp(userpointers[userid]->suserid,"") != 0 && userpointers[userid]->authed == false) {
		authpong(userid);
	}
}
void cmd_pong(int userid, unsigned char* params) {
	trimleft(params);
	if (userpointers[userid]->authpongvalue > 0 && userpointers[userid]->authed == false) {
		if (strstw(params,":") == true) {cut(params,1);trimleft(params);}
		if (atol(params) == userpointers[userid]->authpongvalue) {
			authdone(userid);
		}
	}
	if (userpointers[userid]->ping_waitingforpong > 0 && userpointers[userid]->authed == true) {
		if (strstw(params,":") == true) {cut(params,1);trimleft(params);}
		if (atol(params) == userpointers[userid]->ping_pingval) {
			userpointers[userid]->ping_waitingforpong = 0;
			userpointers[userid]->ping_lastping = time(NULL);
		}
	}
}
void cmd_notice(int userid, unsigned char* params) {
	if (x(userid,"NOTICE")) {return;}
	unsigned char response[513];
	unsigned char targets[100];
	trimleft(params);
	if (charpos(params,' ') <= 0) {
		notenoughparameters(userid,"NOTICE");return;
	}
	if (charpos(params,':') < charpos(params,' ')) {
		notenoughparameters(userid,"NOTICE");return;
	}
	if (charpos(params,':') >= strlen(params) - 1) {
		snprintf(&response[0],499,":%s 412 %s :No text to send",cuo.serverdomain,un(userid));
		response[499] = 0;
		vsnd(response,userid);
		return;
	}
	strncpy(targets,params,99);targets[99] = 0;
	cutonfirstspace(targets);
	cut(params,charpos(params,' ')+1);
	if (strstw(params,":") == false) {
		notenoughparameters(userid,"NOTICE");return;
	}
	cut(params,1);
	if (onlyspaces(params) == true) {
		snprintf(&response[0],499,":%s 412 %s :No text to send",cuo.svd,un(userid));
		vsnd(response,userid);
		return;
	}
	if (strstw(targets,"#") == true) {
		int r = getChanID(targets);
		if (r < 0) {
			snprintf(&response[0],499,":%s 403 %s %s :No such channel",cuo.svd,un(userid),targets);
			vsnd(response,userid);
			return;
		}else{
			if (isuserinchan(userid,r) == false) {
				snprintf(&response[0],499,":%s 404 %s %s :Cannot send to chan",cuo.svd,un(userid),chans[r]->name);
				vsnd(response,userid);
				return;
			}else{
				snprintf(&response[0],499,":%s!%s@%s NOTICE %s :%s",un(userid),userpointers[userid]->suserid,userpointers[userid]->host,chans[r]->name,params);
				tellallusersinchan_exclude(response,r,userid);
				return;
			}
		}
	}else{
		int u;
		u = ubn(targets);
		if (u < 0) {
			if (isfakeuser(targets) == false) {
				snprintf(&response[0],499,":%s 401 %s %s :No such user",cuo.serverdomain,un(userid),targets);
				response[499] = 0;
				vsnd(response,userid);
			}else{
#ifdef SERVICES_ENABLED
				if (isfakeservicesuser(targets) == true) {
					services_gateway_notice(userid,params,targets);
				}
#endif
			}
			return;
		}
		snprintf(&response[0],512,":%s!%s@%s NOTICE %s :%s",un(userid),userpointers[userid]->suserid,userpointers[userid]->host,un(u),params);
		response[512] = 0;
		vsnd(response,u);
		if (userpointers[u]->awayreason != NULL) {
			if (strcasecmp(userpointers[u]->awayreason,"") != 0) {
				snprintf(&response[0],512,":%s 301 %s %s :%s",cuo.svd,un(userid),un(u),userpointers[u]->awayreason);
				response[512] = 0;
				vsnd(response,userid);
			}
		}
		return;
	}
}
void cmd_ping(int userid, unsigned char* params) {
	unsigned char response[313];
	trimleft(params);
	if (strstw(params,":") == true) {cut(params,1);}trimleft(params);
	cutonfirstspace(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"PING");return;
	}
	snprintf(&response[0],312,":%s PONG %s :%s",cuo.svd,cuo.svd,params);
	response[312] = 0;vsnd(response,userid);
}
void cmd_privmsg(int userid, unsigned char* params) {
	if (x(userid,"PRIVMSG")) {return;}
	unsigned char response[513];
	unsigned char targets[100];
	trimleft(params);
	if (charpos(params,' ') <= 0) {
		notenoughparameters(userid,"PRIVMSG");return;
	}
	if (charpos(params,':') < charpos(params,' ')) {
		notenoughparameters(userid,"PRIVMSG");return;
	}
	if (charpos(params,':') >= strlen(params) - 1) {
		snprintf(&response[0],499,":%s 412 %s :No text to send",cuo.serverdomain,un(userid));
		response[499] = 0;
		vsnd(response,userid);
		return;
	}
	strncpy(targets,params,99);targets[99] = 0;
	cutonfirstspace(targets);
	cut(params,charpos(params,' ')+1);
	if (strstw(params,":") == false) {
		notenoughparameters(userid,"PRIVMSG");return;
	}
	cut(params,1);
	if (onlyspaces(params) == true) {
		snprintf(&response[0],499,":%s 412 %s :No text to send",cuo.svd,un(userid));
		vsnd(response,userid);
		return;
	}
	if (strstw(targets,"#") == true) {
		int r = getChanID(targets);
		if (r < 0) {
			snprintf(&response[0],499,":%s 403 %s %s :No such channel",cuo.svd,un(userid),targets);
			vsnd(response,userid);
			return;
		}else{
			if (isuserinchan(userid,r) == false) {
				snprintf(&response[0],499,":%s 404 %s %s :Cannot send to chan",cuo.svd,un(userid),chans[r]->name);
				vsnd(response,userid);
				return;
			}else{
				snprintf(&response[0],499,":%s!%s@%s PRIVMSG %s :%s",un(userid),userpointers[userid]->suserid,userpointers[userid]->host,chans[r]->name,params);
				tellallusersinchan_exclude(response,r,userid);
				return;
			}
		}
	}else{
		int u;
		u = ubn(targets);
		if (u < 0) {
			if (isfakeuser(targets) == false) {
				snprintf(&response[0],499,":%s 401 %s %s :No such user",cuo.serverdomain,un(userid),targets);
				response[499] = 0;
				vsnd(response,userid);
			}else{
#ifdef SERVICES_ENABLED
				if (isfakeservicesuser(targets) == true) {
					services_gateway_privmsg(userid,params,targets);
				}
#endif
			}
			return;
		}
		snprintf(&response[0],512,":%s!%s@%s PRIVMSG %s :%s",un(userid),userpointers[userid]->suserid,userpointers[userid]->host,un(u),params);
		response[512] = 0;
		vsnd(response,u);
		if (userpointers[u]->awayreason != NULL) {
			if (strcasecmp(userpointers[u]->awayreason,"") != 0) {
				snprintf(&response[0],512,":%s 301 %s %s :%s",cuo.svd,un(userid),un(u),userpointers[u]->awayreason);
				response[512] = 0;
				vsnd(response,userid);
			}
		}
		return;
	}
}
void cmd_whois2(int userid, unsigned char* params) {
	unsigned char response[513];
	unsigned char pam[50];
	strncpy(pam,params,49);
	pam[49] = 0;
	int u;
	u = ubn(params);
	if (u < 0) {
#ifdef SERVICES_ENABLED
		if (isfakeservicesuser(params) == true) {
			writeservicesnick(pam);
			snprintf(&response[0],499,":%s 311 %s %s services %s * :Services",cuo.svd,un(userid),pam,cuo.serviceshost);
			response[499] = 0;vsnd(response,userid);
			snprintf(&response[0],499,":%s 312 %s %s %s :%s",cuo.svd,un(userid),pam,cuo.svd,cuo.svd);
			response[499] = 0;vsnd(response,userid);
			snprintf(&response[0],499,":%s 335 %s %s :is a services bot",cuo.svd,un(userid),pam);
			response[499] = 0;vsnd(response,userid);
			snprintf(&response[0],499,":%s 318 %s %s :End of /WHOIS",cuo.svd,un(userid),pam);
			response[499] = 0;vsnd(response,userid);
			return;
		}
#endif
		snprintf(&response[0],499,":%s 401 %s %s :No such user",cuo.serverdomain,un(userid),params);
		response[499] = 0;
		vsnd(response,userid);
		return;
	}
	sendwhois(userid,u);
}
void cmd_whois(int userid, unsigned char* params) {
	if (x(userid,"WHOIS")) {return;}
	unsigned char tp1[500];
	unsigned char tp2[500];
	trimleft(params);cutonfirstspace(params);
	if (strcasecmp(params,"") == 0) {
		notenoughparameters(userid,"WHOIS");return;
	}
	strncpy(tp1,params,499);tp1[499] = 0;
	int r = 0;int count = 0;
	while (charpos(tp1,',') > 0) {
		count++;if (count > 2) {userpointers[userid]->floodprotect.floodpoints += 2;}
		if (count > 10) {userpointers[userid]->floodprotect.floodpoints += 8;}
		if (count > 15) {return;}
		allesvorzeichen(',',tp2,tp1);
		allesnachzeichen(',',tp1,tp1);
		cmd_whois2(userid,tp2);
	}
	count++;if (count > 2) {userpointers[userid]->floodprotect.floodpoints += 3;}
	if (count > 10) {userpointers[userid]->floodprotect.floodpoints += 8;}
	cmd_whois2(userid,tp1);
}
void cmd_quit(int userid, unsigned char* params) {
	trimleft(params);
	if (strstw(params,":") == true) {cut(params,1);}
	trimleft(params);
	trimright(params);
	if (strcasecmp(params,"") != 0 && userpointers[userid]->quitreason == NULL) {
		userpointers[userid]->quitreason = malloc(strlen(params) + 1);
		if (userpointers[userid]->quitreason != NULL) {
			strcpy(userpointers[userid]->quitreason,"");
			int r = 0;
			while (r < strlen(params)) {
				if (params[r] != 2 && params[r] != 3) {//no bold, no colours
					userpointers[userid]->quitreason[strlen(userpointers[userid]->quitreason) + 1] = 0;
					userpointers[userid]->quitreason[strlen(userpointers[userid]->quitreason)] = params[r];
				}
				r += 1;
			}
			if (strlen(userpointers[userid]->quitreason) <= 0) {
				free(userpointers[userid]->quitreason);
				userpointers[userid]->quitreason = NULL;
			}
		}
	}
	userQuit(userid,USERQUIT_QUIT);
}
void cmd_user(int userid, unsigned char* params) {
	unsigned char response[500];
	if (strcasecmp(userpointers[userid]->suserid,"") != 0) {
		if (strcasecmp(userpointers[userid]->nickname,"") == 0) {
			snprintf(&response[0],499,":%s 462 * :Please register only once",cuo.svd);
		}else{
			snprintf(&response[0],499,":%s 462 %s :Please register only once",cuo.svd,un(userid));
		}
		response[499] = 0;
		vsnd(response,userid);
		return;
	}
	trimleft(params);
	if (charpos(params,' ') <= 0) {
		notenoughparameters(userid,"USER");return;
	}
	if (charpos(params,':') < charpos(params,' ')) {
		notenoughparameters(userid,"USER");return;
	}
	unsigned char muserid[10] = "";
	strncpy(muserid,params,9);muserid[9] = 0;
	cutonfirstspace(muserid);
	makeuseridvalid(muserid);
	if (strlen(muserid) <= 0) {strcpy(muserid,"invalid");}
	strcpy(userpointers[userid]->suserid,"~");strncat(userpointers[userid]->suserid,muserid,COMPILEOPTION_MAXUSERIDLEN -1);
	userpointers[userid]->suserid[COMPILEOPTION_MAXUSERIDLEN] = 0;
	allesnachzeichen(':',params,params);
	trimleft(params);trimright(params);
	strncpy(userpointers[userid]->realname,params,COMPILEOPTION_MAXREALNAMELEN - 1);
	userpointers[userid]->realname[COMPILEOPTION_MAXREALNAMELEN] = 0;
	if (strcasecmp(userpointers[userid]->nickname,"") != 0) {
		authpong(userid);
	}
}
