//    WeIRCd IRC server software - sub file
//    Copyright (C) 2007, 2008 Jonas Thiem
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.

#define MAXUSERMASKLEN 300
bool starmatch(char* mstring,char* mask,int recursivecount) {
	//printf("ok let's go with %s and %s...\n",mstring,mask);
	if (recursivecount < 0) {return false;}
	char lclmaskcpy[600];
	char lclstringcpy[600];
	strlwr(mstring);strlwr(mask);
	strncpy(lclmaskcpy,mask,599);lclmaskcpy[599] = 0;
	strncpy(lclstringcpy,mstring,599);lclstringcpy[599] = 0;
	int trypos = 0;
	int r;
	if (strlen(mask) == 1) {
		if (mask[0] == '*') {
			return true;
		}else{
			if (strlen(mstring) != 1) {return false;}
			if (mstring[0] != mask[0]) {return false;}
			return true;
   	}
	}
	if (strlen(mask) <= 1) {return false;}
	if (mask[0] != '*') {return false;}
	//printf("with %s and %s\n",mstring,mask);
	while (trypos < strlen(mstring)) {
		if (mstring[trypos] == mask[1]) {//suche etwas, das mit dem nach dem * passen könnte, und teste dann dort weiter. wenns passt => gut :-)
			r = trypos;
			while (r < strlen(mstring)) {
				if ((r - trypos) > strlen(mask) - 1) {break;}
				if (mask[(r - trypos) + 1] == '*') {
					//printf("found at pos %d\n",(r-trypos)+1);
					cut(lclmaskcpy,(r - trypos) + 1);
					cut(lclstringcpy,r);
					if (starmatch(lclstringcpy,lclmaskcpy,recursivecount - 1) == false) {
						break;
					}else{
						return true;
					}
				}else{
					if (mstring[r] != mask[(r - trypos) + 1]) {
						break;
					}else{
						//printf("r: %d r-trypos: %d\n",(r),r-trypos);
						if ((r - trypos) >= strlen(mask) - 2 && r == strlen(mstring) - 1) {
							//printf("success:end!\n");
							return true;
						}
						if (r >= strlen(mstring) - 1) {
							if ((r - trypos) == strlen(mask) - 3) {
								if (mask[(r - trypos) + 2] == '*') {//printf("success:just a star left\n");
									return true;
								}else{break;}
							}
						}
					}
				}
				r += 1;
			}
		}
		trypos += 1;
	}
	return false;//leider hat nix gepasst. damit matcht das ganze auch ned.
}
bool matches(const unsigned char* mstring,const unsigned char* mask) {
	int laststar = 0;
	int pos = 0;
	int r = 0;int k = 0;
	char lclmask[600];
	char lclstring[600];
	if (charpos(mask,'*') < 0) {if (strcasecmp(mstring,mask) == 0) {return true;}else{return false;}}
	if (strlen(mstring) <= 0) {return false;}
	if (strlen(mask) == 1 && strlen(mstring) > 1) {if (mask[0] != '*') {return false;}else{return true;}}
	strncpy(lclmask,mask,599);
	lclmask[599] = 0;
	strlwr(lclmask);
	strncpy(lclstring,mstring,599);
	lclstring[599] = 0;
	strlwr(lclstring);
	while (r < strlen(lclmask) - 1) {
		if (lclmask[r] == '*' && lclmask[r + 1] == '*') {
			while (lclmask[r + 1] == '*') {
				k = r;
				while (k < strlen(lclmask) - 1) {
					lclmask[k] = lclmask[k + 1];
					k += 1;
				}
			}
		}
		r += 1;
	}
	//printf("%s\n",lclmask);
	char lclmaskcpy[600];
	char lclstringcpy[600];
	pos = 0;
	while (pos < strlen(lclmask)) {
		if (pos >= strlen(lclstring)) {return false;}
		if (lclmask[pos] != '*') {
			if (lclmask[pos] != lclstring[pos]) {return false;}
		}else{
			strncpy(lclmaskcpy,lclmask,599);lclmaskcpy[599] = 0;
			strncpy(lclstringcpy,lclstring,599);lclstringcpy[599] = 0;
			if (pos > 0) {cut(lclmaskcpy,pos);cut(lclstringcpy,pos);}
			if (starmatch(lclstringcpy,lclmaskcpy,10) == false) {return false;}else{return true;}
		}
		pos += 1;
	}
	return true;
}
void makevalidmask(char* mymask) {
	mymask[MAXUSERMASKLEN] = 0;
	unsigned char lclmaskcpy[MAXUSERMASKLEN + 1] = "\0";
	int r = 0;
	int k = 0;
	while (r < strlen(mymask)) {
		if (mymask[r] > 30 && mymask[r] != '#' && mymask[r] != ' ' && mymask[r] != ',' && mymask[r] != 30 && mymask[r] < 127) {
			if (r < strlen(mymask) - 1) {
				if (mymask[r] == '*' && mymask[r + 1] == '*') {r += 1;continue;}//no doubled *
			}
			lclmaskcpy[strlen(lclmaskcpy) + 1] = '\0';
			lclmaskcpy[strlen(lclmaskcpy)] = mymask[r];
		}
		r += 1;
	}
	strlwr(lclmaskcpy);
	//strncpy(lclmaskcpy,mymask,MAXUSERMASKLEN);
	lclmaskcpy[MAXUSERMASKLEN - 1] = 0;
	if (charpos(lclmaskcpy,'!') > MAXUSERMASKLEN - 5) {lclmaskcpy[MAXUSERMASKLEN - 5] = 0;}
	if (charpos(lclmaskcpy,'!') <= 0) {
		if (charpos(lclmaskcpy,'!') == 0) {// ! is at the start
			lclmaskcpy[MAXUSERMASKLEN - 1] = 0;
			r = (strlen(lclmaskcpy) - 1) + 1;
			while (r > 0) {
				lclmaskcpy[r] = lclmaskcpy[r - 1];
				r -= 1;
			}
			lclmaskcpy[0] = '*';
			if (charpos(lclmaskcpy,'@') < 0) {
				if (lclmaskcpy[strlen(lclmaskcpy) - 1] == '!') {lclmaskcpy[MAXUSERMASKLEN - 4] = 0;strcat(lclmaskcpy,"*");}
				lclmaskcpy[MAXUSERMASKLEN - 3] = 0;strcat(lclmaskcpy,"@*");
			}else{
				if (charpos(lclmaskcpy,'@') == charpos(lclmaskcpy,'!') + 1) {//no userid, e.g. *!@
					lclmaskcpy[MAXUSERMASKLEN - 2] = 0;
					r = strlen(lclmaskcpy);k = charpos(lclmaskcpy,'@');
					lclmaskcpy[strlen(lclmaskcpy) + 1] = 0;
					while (r > k) {
						lclmaskcpy[r] = lclmaskcpy[r - 1];
						r -= 1;
					}
					lclmaskcpy[k] = '*';
				}
			}
			if (charpos(lclmaskcpy,'@') == strlen(lclmaskcpy) - 1) {//no host, e.g. *!*@
				lclmaskcpy[MAXUSERMASKLEN - 2] = 0;strcat(lclmaskcpy,"*");
			}
		}else{// ! is missing
			if (charpos(lclmaskcpy,'@') < 0) {// @ is missing too
				lclmaskcpy[MAXUSERMASKLEN - 4] = 0;
				strcat(lclmaskcpy,"!*@*");
			}else{
				if (charpos(lclmaskcpy,'@') == 0) { // @ is at the beginning
					lclmaskcpy[MAXUSERMASKLEN - 4] = 0;
					lclmaskcpy[(strlen(lclmaskcpy) - 1) + 5] = 0;
					r = (strlen(lclmaskcpy) - 1) + 4;
					while (r > 2) {
						lclmaskcpy[r] = lclmaskcpy[r - 3];
						r -= 1;
					}
					lclmaskcpy[0] = '*';lclmaskcpy[1] = '!';lclmaskcpy[2] = '*';lclmaskcpy[3] = '@'; 
				}else{ // @ is somewhere at the end
					lclmaskcpy[MAXUSERMASKLEN - 2] = 0;
					lclmaskcpy[(strlen(lclmaskcpy) - 1) + 3] = 0;
					r = (strlen(lclmaskcpy) - 1) + 2;
					while (r > 1) {
						lclmaskcpy[r] = lclmaskcpy[r - 2];
						r -= 1;
					}
					lclmaskcpy[0] = '*';lclmaskcpy[1] = '!';
				}
				if (charpos(lclmaskcpy,'@') == strlen(lclmaskcpy) - 1) {//no host, e.g. *!*@
					lclmaskcpy[MAXUSERMASKLEN - 2] = 0;strcat(lclmaskcpy,"*");
				}
			}
		}
	}else{
		if (charpos(lclmaskcpy,'@') < 0) {
			if (lclmaskcpy[strlen(lclmaskcpy)-1] == '!') {//no userid, e.g. *!
				lclmaskcpy[MAXUSERMASKLEN - 4] = 0;strcat(lclmaskcpy,"*");
			}
			lclmaskcpy[MAXUSERMASKLEN - 3] = 0;strcat(lclmaskcpy,"@*");
		}else{
			if (charpos(lclmaskcpy,'@') < charpos(lclmaskcpy,'!')) {
				lclmaskcpy[charpos(lclmaskcpy,'!')] = '\0';
				lclmaskcpy[MAXUSERMASKLEN - 2] = 0;
				lclmaskcpy[(strlen(lclmaskcpy) - 1) + 3] = 0;
				r = (strlen(lclmaskcpy) - 1) + 2;
				while (r > 1) {
					lclmaskcpy[r] = lclmaskcpy[r - 2];
					r -= 1;
				}
				lclmaskcpy[0] = '*';lclmaskcpy[1] = '!';
			}
			if (charpos(lclmaskcpy,'@') == charpos(lclmaskcpy,'!') + 1) {//no userid, e.g. *!@
				lclmaskcpy[MAXUSERMASKLEN - 2] = 0;
				r = strlen(lclmaskcpy);k = charpos(lclmaskcpy,'@');
				lclmaskcpy[strlen(lclmaskcpy) + 1] = 0;
				while (r > k) {
					lclmaskcpy[r] = lclmaskcpy[r - 1];
					r -= 1;
				}
				lclmaskcpy[k] = '*';
			}
			if (charpos(lclmaskcpy,'@') == strlen(lclmaskcpy) - 1) {//no host, e.g. *!*@
				lclmaskcpy[MAXUSERMASKLEN - 2] = 0;strcat(lclmaskcpy,"*");
			}
		}
	}
	strcpy(mymask,lclmaskcpy);
}
